Bug 225321 - Add Data Call ICs that don't repatch and use them in the baseline JIT
Summary: Add Data Call ICs that don't repatch and use them in the baseline JIT
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Saam Barati
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2021-05-03 12:00 PDT by Saam Barati
Modified: 2021-05-18 14:30 PDT (History)
9 users (show)

See Also:


Attachments
WIP (104.82 KB, patch)
2021-05-11 17:05 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
WIP (102.93 KB, patch)
2021-05-12 18:08 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
WIP (102.98 KB, patch)
2021-05-12 18:14 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
WIP (99.87 KB, patch)
2021-05-12 18:23 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
WIP (98.05 KB, patch)
2021-05-13 10:21 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
WIP (77.39 KB, patch)
2021-05-13 11:01 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
WIP (77.33 KB, patch)
2021-05-13 11:04 PDT, Saam Barati
ews-feeder: commit-queue-
Details | Formatted Diff | Diff
WIP (84.20 KB, patch)
2021-05-13 12:05 PDT, Saam Barati
ews-feeder: commit-queue-
Details | Formatted Diff | Diff
patch (88.43 KB, patch)
2021-05-13 17:12 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
patch (88.55 KB, patch)
2021-05-13 17:13 PDT, Saam Barati
no flags Details | Formatted Diff | Diff
patch (88.48 KB, patch)
2021-05-14 10:42 PDT, Saam Barati
msaboff: review+
ews-feeder: commit-queue-
Details | Formatted Diff | Diff
patch for landing (88.56 KB, patch)
2021-05-17 13:34 PDT, Saam Barati
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Saam Barati 2021-05-03 12:00:32 PDT
...
Comment 1 Radar WebKit Bug Importer 2021-05-10 12:01:22 PDT
<rdar://problem/77773796>
Comment 2 Saam Barati 2021-05-11 17:05:02 PDT
Created attachment 428329 [details]
WIP
Comment 3 Saam Barati 2021-05-12 18:08:57 PDT
Created attachment 428441 [details]
WIP

Still need to implement 32-bit, but let's see how x86_64 does
Comment 4 Saam Barati 2021-05-12 18:14:36 PDT
Created attachment 428444 [details]
WIP
Comment 5 Saam Barati 2021-05-12 18:23:45 PDT
Created attachment 428445 [details]
WIP
Comment 6 Saam Barati 2021-05-13 10:21:13 PDT
Created attachment 428525 [details]
WIP
Comment 7 Saam Barati 2021-05-13 11:01:59 PDT
Created attachment 428533 [details]
WIP

rebased, the patch should apply to ToT now.
Comment 8 Saam Barati 2021-05-13 11:04:50 PDT
Created attachment 428535 [details]
WIP
Comment 9 Saam Barati 2021-05-13 12:05:43 PDT
Created attachment 428541 [details]
WIP
Comment 10 Saam Barati 2021-05-13 17:12:15 PDT
Created attachment 428581 [details]
patch
Comment 11 Saam Barati 2021-05-13 17:13:50 PDT
Created attachment 428582 [details]
patch
Comment 12 Saam Barati 2021-05-14 10:39:10 PDT
Comment on attachment 428582 [details]
patch

View in context: https://bugs.webkit.org/attachment.cgi?id=428582&action=review

> Source/JavaScriptCore/jit/JITCall32_64.cpp:306
> +    if (opcodeID == op_tail_call || opcodeID == op_tail_call_varargs || opcodeID == op_tail_call_forward_arguments)

lol, this should not be here...

I think this is the 32-bit crashes
Comment 13 Saam Barati 2021-05-14 10:42:26 PDT
Created attachment 428638 [details]
patch
Comment 14 Michael Saboff 2021-05-17 11:13:52 PDT
Comment on attachment 428638 [details]
patch

View in context: https://bugs.webkit.org/attachment.cgi?id=428638&action=review

r=me with one nit.

> Source/JavaScriptCore/ChangeLog:10
> +        pointer from CallLinkInfo, and indrect calling that pointer. This means that

nit -> indirect
Comment 15 Saam Barati 2021-05-17 13:34:34 PDT
Created attachment 428860 [details]
patch for landing
Comment 16 Saam Barati 2021-05-18 14:04:47 PDT
Getting help from Caio on Slack. He isn't able to reproduce the failure locally. Will land for now, and we'll fix testapi on armv7 if failures are caused.
Comment 17 EWS 2021-05-18 14:30:56 PDT
Committed r277680 (237881@main): <https://commits.webkit.org/237881@main>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 428860 [details].